//#include "ClientSocket.h"
//#include "TestPacket.h"

#include "RakNetworkFactory.h"
#include "RakClientInterface.h"
#include "PacketEnumerations.h"

#include <iostream>

#ifdef WIN32
  #include <windows.h>
  #define snooze(n) Sleep(n)
#else
  #include <unistd.h>
  #define snooze(n) usleep(n * 1000);
#endif

using namespace std;

int main(int argc, char *argv[]) {

  // Create a client object  
  RakClientInterface *client = RakNetworkFactory::GetRakClientInterface();
  
  // Connect to the server
  cout << "Connecting to the server..." << endl;
  client->Connect("localhost", 4000, 4001, 0, 0);
  snooze(500);
  
  // Wait while the connection is built
  while(!client->IsConnected()) {
    snooze(30);
  }
  cout << "Connected to the server!" << endl;
  
  // Build packet (note: this packet is similar, but not equal to TestPacket)
  char packet[1] = {ID_RESERVED9 + 1};
  
  // Send packet
  client->Send(packet, 1, HIGH_PRIORITY, RELIABLE_ORDERED, 0);
  snooze(500);
  
  RakNetworkFactory::DestroyRakClientInterface(client);
  return 0;

/*  // Create connection
  ClientSocket *cs = new ClientSocket();
  if(!cs->Connect("localhost", 4000)) {
    return -1;
  }
  
  // Create packet
  TestPacket *tp = new TestPacket();
  
  // Send packet
  cs->SendPacket(tp);
  
  cout << "Sent packet!" << endl;
  
  // Receive a packet
  Packet *packet = cs->ReceivePacket();
  
  if(packet != NULL) {
    cout << "Packet received!" << endl;
    
    if(packet->GetType() == 2) {
      cout << "The packet has the right type! :D" << endl;
    }
    
    delete packet;
  }
  
  // Clean up
  delete tp;
  delete cs;
  
  return 0;*/
}
