//#include "ServerSocket.h"
//#include "TestReplyPacket.h"
//#include "Map.h"

#include "RakNetworkFactory.h"
#include "RakServerInterface.h"
#include "PacketEnumerations.h"

#include <iostream>

#ifdef WIN32
  #include <windows.h>
  #define snooze(n) Sleep(n)
#else
  #include <unistd.h>
  #define snooze(n) usleep(n * 1000);
#endif

using namespace std;

int main(int argc, char *argv[]) {
  
  RakServerInterface *server = RakNetworkFactory::GetRakServerInterface();
  
  // Create a server on port 4000
//  server->Initialize(1, 4000, 30, NULL);
  server->Start(1, 0, 30, 4000);

  snooze(500);
  
  // Start processing packets
  while(1) {
    Packet *packet = server->Receive();
    
    if(packet) {
      // Detect our own packet
      if(packet->data[0] == ID_RESERVED9 + 1) {
        cout << "Packet from the client arrived! Quitting now. :)" << endl;
        
        break;
      }
      
      // Clean up
      server->DeallocatePacket(packet);
    }
    
    snooze(30);
  }
  
  RakNetworkFactory::DestroyRakServerInterface(server);
  return 0;
  
/*  // Create a random map
  Map *map = new Map();
  map->Random(16, 16);
  
  // Create connection
  ServerSocket *ss = new ServerSocket();
  if(!ss->OpenPort(4000)) {
    return -1;
  }
  
  // Accept an incoming connection
  ServerSocket *cns = ss->AcceptConnection();
  
  if(cns == NULL) {
    return -1;
  }
  
  // Receive a packet
  Packet *packet = cns->ReceivePacket();
  
  if(packet != NULL) {
    cout << "Packet received!" << endl;
    
    if(packet->GetType() == 1) {
      cout << "The packet has the right type! :D" << endl;
    }
  } else {
    delete packet;
    delete cns;
    delete ss;
    delete map;
    return -1;
  }
  
  // Send a reply
  delete packet;
  packet = new TestReplyPacket();
  
  cns->SendPacket(packet);
  
  cout << "Sent reply." << endl;
  
  // Clean up
  delete packet;
  delete cns;
  delete ss;
  delete map;
  
  return 0; */
}
